local addonName, L = ...;

function ALUF_PlayerFrame_OnLoad (self)
	
	ArenaLive_SecureUnitButton_OnLoad(self, nil, nil, true);
	
	local numCastHistoryIcons = ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["castHistory"]["shownIcons"];
	local castHistoryIconSize = ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["castHistory"]["iconSize"];

	self.statusCounter = 0;
	self.statusSign = -1;
	self.levelText = ALUF_PlayerFrameLevelText;
	self.statusTexture = ALUF_PlayerFrameStatusTexture;
	self.attackBackground = ALUF_PlayerFrameAttackBackground;
	self.PVPIcon = ALUF_PlayerFramePVPIcon;
	self.leaderIcon = ALUF_PlayerFrameLeaderIcon;
	self.guideIcon = ALUF_PlayerFrameGuideIcon;
	self.masterLooterIcon = ALUF_PlayerFrameMasterLooterIcon;
	self.restIcon = ALUF_PlayerFrameRestIcon;
	self.attackIcon = ALUF_PlayerFrameAttackIcon;
	self.roleIcon = ALUF_PlayerFrameRoleIcon;
	self.speakerFrame = ALUF_PlayerFrameSpeakerFrame;
	self.ReadyCheck = ALUF_PlayerFrameReadyCheck;
	self.statusGlow = ALUF_PlayerFrameStatusGlow;
	self.statusGlow.restGlow = ALUF_PlayerFrameStatusGlowRestGlow;
	self.statusGlow.attackGlow = ALUF_PlayerFrameStatusGlowAttackGlow;
	self.multiGroupFrame = ALUF_PlayerFrameMultiGroupFrame;
	self.multiGroupFrame.homePartyIcon = ALUF_PlayerFrameMultiGroupFrameHomePartyIcon
	self.multiGroupFrame.instancePartyIcon = ALUF_PlayerFrameMultiGroupFrameInstancePartyIcon
	
	ArenaLive_UnitFrame_Initialise(self, "ArenaLiveUnitFrames", "playerFrame", ALUF_PlayerFrameBackground, ALUF_PlayerFrameBorder, ALUF_PlayerFrameName, ALUF_PlayerFramePortrait, ALUF_PlayerFrame3DPortrait, ALUF_PlayerFramePortraitOverlay, ALUF_PlayerFrameHealthBar, ALUF_PlayerFrameHealthBarText, ALUF_PlayerFramePowerBar, ALUF_PlayerFramePowerBarText, nil, nil, ALUF_PlayerFrameHealPredictionBar, ALUF_PlayerFrameAbsorbBar, ALUF_PlayerFrameAbsorbBarOverlay, ALUF_PlayerFrameAbsorbFullHPIndicator);
	ArenaLive_UnitFrame_UpdateUnit(self, "player");
	ArenaLive_Icon_Initialise(ALUF_PlayerFrameIcon1, "ArenaLiveUnitFrames", "playerFrame", 1, ALUF_PlayerFrameIcon1Texture, ALUF_PlayerFrameIcon1Cooldown);
	ArenaLive_Icon_UpdateUnit(ALUF_PlayerFrameIcon1, "player");
	ArenaLive_Icon_Initialise(ALUF_PlayerFrameIcon2, "ArenaLiveUnitFrames", "playerFrame", 2, ALUF_PlayerFrameIcon2Texture, ALUF_PlayerFrameIcon2Cooldown);
	ArenaLive_Icon_UpdateUnit(ALUF_PlayerFrameIcon2, "player");
	ArenaLive_CastBar_Initialise(ALUF_PlayerFrameCastBar, "ArenaLiveUnitFrames", "playerFrame", ALUF_PlayerFrameCastBarBorder, ALUF_PlayerFrameBorderShieldGlow, ALUF_PlayerFrameCastBarIcon, ALUF_PlayerFrameCastBarText, ALUF_PlayerFrameCastBarAnimationGroup, ALUF_PlayerFrameCastBarAnimationGroupFadeOutAnimation, false, true);
	ArenaLive_CastHistory_Initialise(ALUF_PlayerFrameCastHistory, "ArenaLiveUnitFrames", "playerFrame", numCastHistoryIcons, "ArenaLive_CastHistoryIconTemplate", "right");
	ArenaLive_AuraFrame_Initialise(ALUF_PlayerFrameAuras, "ArenaLiveUnitFrames", "playerFrame", ALUF_PlayerFrameAurasBuffFrame, ALUF_PlayerFrameAurasDebuffFrame, "ArenaLive_BuffTemplate", "ArenaLive_DebuffTemplate");

	-- Units for Castbar, casthistory and auraFrame will be set with this function, aswell as there positions towards the frame.
	ALUF_PlayerFrame_AdjustAttachments(self);

	-- Use the Blizzard AltPowerBars ans attach them to our PlayerFrame.
	local _, class = UnitClass("player");	
	if ( class == "WARLOCK" ) then
		WarlockPowerFrame:SetParent(ALUF_PlayerFrame);
		WarlockPowerFrame:ClearAllPoints();
		WarlockPowerFrame:SetPoint("TOP", ALUF_PlayerFrame, "BOTTOM", 0, 9 );
	elseif ( class == "SHAMAN" ) then
		TotemFrame:SetParent(ALUF_PlayerFrame);
		TotemFrame:ClearAllPoints();
		TotemFrame:SetPoint("TOP", ALUF_PlayerFrame, "BOTTOM", 0, 9 );
	elseif ( class == "DRUID" ) then
		EclipseBarFrame:SetParent(ALUF_PlayerFrame);
		EclipseBarFrame:ClearAllPoints();
		EclipseBarFrame:SetPoint("TOP", ALUF_PlayerFrame, "BOTTOM", 0, 9 );
	elseif ( class == "PALADIN" ) then
		PaladinPowerBar:SetParent(ALUF_PlayerFrame);
		PaladinPowerBar:ClearAllPoints();
		PaladinPowerBar:SetPoint("TOP", ALUF_PlayerFrame, "BOTTOM", 0, 9 );
	elseif ( class == "DEATHKNIGHT" ) then
		RuneFrame:SetParent(ALUF_PlayerFrame);
		RuneFrame:ClearAllPoints();
		RuneFrame:SetPoint("TOP", ALUF_PlayerFrame, "BOTTOM", 0, 2 );
	elseif ( class == "PRIEST" ) then
		PriestBarFrame:SetParent(ALUF_PlayerFrame);
		PriestBarFrame:ClearAllPoints();
		PriestBarFrame:SetPoint("TOP", ALUF_PlayerFrame, "BOTTOM", 0, 9 );
	elseif ( class == "MONK" ) then
		MonkHarmonyBar:SetParent(ALUF_PlayerFrame);
		MonkHarmonyBar:ClearAllPoints();
		MonkHarmonyBar:SetPoint("TOPRIGHT", ALUF_PlayerFrame, "BOTTOMRIGHT", -70, 25 );
	end
	
	self:RegisterEvent("UNIT_LEVEL");
	self:RegisterEvent("UNIT_FACTION");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("PLAYER_ENTER_COMBAT");
	self:RegisterEvent("PLAYER_LEAVE_COMBAT");
	self:RegisterEvent("PLAYER_REGEN_DISABLED");
	self:RegisterEvent("PLAYER_REGEN_ENABLED");
	self:RegisterEvent("PLAYER_UPDATE_RESTING");
	self:RegisterEvent("PARTY_LEADER_CHANGED");
	self:RegisterEvent("PARTY_LOOT_METHOD_CHANGED");
	self:RegisterEvent("VOICE_START");
	self:RegisterEvent("VOICE_STOP");
	self:RegisterEvent("GROUP_ROSTER_UPDATE");
	self:RegisterEvent("READY_CHECK");
	self:RegisterEvent("READY_CHECK_CONFIRM");
	self:RegisterEvent("READY_CHECK_FINISHED");
	self:RegisterEvent("UNIT_ENTERED_VEHICLE");
	self:RegisterEvent("UNIT_EXITED_VEHICLE");
	self:RegisterEvent("PLAYER_FLAGS_CHANGED");
	self:RegisterEvent("PLAYER_ROLES_ASSIGNED");
	self:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED");
	self:RegisterEvent("VARIABLES_LOADED");
	self:RegisterUnitEvent("UNIT_COMBAT", "player", "vehicle");
	self:RegisterUnitEvent("UNIT_MAXPOWER", "player", "vehicle");
 
	ALUF_PlayerFrame_Update(self);
end



function ALUF_PlayerFrame_Update(self)
	if ( UnitExists("player") ) then
		self.levelText:SetText(UnitLevel(self.unit));
		ArenaLive_UnitFrame_Update(self)
		ArenaLive_Icon_Update(self.icon1);
		ArenaLive_Icon_Update(self.icon2);
		
		ALUF_PlayerFrame_UpdatePartyLeader(self);
		ALUF_PlayerFrame_UpdatePvPStatus(self);
		ALUF_PlayerFrame_UpdateStatus(self);
	end
end



function ALUF_PlayerFrame_UpdatePartyLeader(self)
	
	if ( UnitIsGroupLeader("player") ) then
		if ( HasLFGRestrictions() ) then
			self.guideIcon:Show();
			self.leaderIcon:Hide();
		else
			self.leaderIcon:Show()
			self.guideIcon:Hide();
		end
	else
		self.leaderIcon:Hide();
		self.guideIcon:Hide();
	end

	local lootMethod;
	local lootMaster;
	lootMethod, lootMaster = GetLootMethod();
	if ( lootMaster == 0 and IsInGroup() ) then
		self.masterLooterIcon:Show();
	else
		self.masterLooterIcon:Hide();
	end
end



function ALUF_PlayerFrame_UpdatePvPStatus(self)
	
	local factionGroup, factionName = UnitFactionGroup("player");
	if ( UnitIsPVPFreeForAll("player") ) then
		
		if ( not self.PVPIcon:IsShown() ) then
			PlaySound("igPVPUpdate");
		end
		
		self.PVPIcon:SetTexture("Interface\\TargetingFrame\\UI-PVP-FFA");
		self.PVPIcon:Show();
		
	elseif ( factionGroup and factionGroup ~= "Neutral" and UnitIsPVP("player") ) then
		
		if ( not self.PVPIcon:IsShown() ) then
			PlaySound("igPVPUpdate");
		end
		
		self.PVPIcon:SetTexture("Interface\\TargetingFrame\\UI-PVP-"..factionGroup);
		self.PVPIcon:Show();
	else
		self.PVPIcon:Hide();
	end
end



function ALUF_PlayerFrame_OnEvent (self, event, ...)

	ArenaLive_UnitFrame_OnEvent(self, event, ...);
	
	local arg1, arg2, arg3, arg4, arg5 = ...;
	
	if ( event == "UNIT_LEVEL" ) then
		if ( arg1 == "player" ) then
			self.levelText:SetText(UnitLevel(self.unit));
		end
	elseif ( event == "UNIT_FACTION" ) then
		if ( arg1 == "player" ) then
			ALUF_PlayerFrame_UpdatePvPStatus(self);
		end
	elseif ( event == "PLAYER_ENTERING_WORLD" ) then		
		self.inCombat = nil;
		self.onHateList = nil;
		ALUF_PlayerFrame_Update(self);
		ALUF_PlayerFrame_UpdateRolesAssigned(self);
		ALUF_PlayerFrame_AdjustAttachments(self);
		self.speakerFrame:Show();
		ALUF_PlayerFrame_UpdateVoiceStatus(UnitIsTalking(UnitName("player")));

	elseif ( event == "PLAYER_ENTER_COMBAT" ) then
		self.inCombat = 1;
		ALUF_PlayerFrame_UpdateStatus(self)
	elseif ( event == "PLAYER_LEAVE_COMBAT" ) then
		self.inCombat = nil;
		ALUF_PlayerFrame_UpdateStatus(self)
	elseif ( event == "PLAYER_REGEN_DISABLED" ) then
		self.onHateList = 1;
		ALUF_PlayerFrame_UpdateStatus(self);
		
		if ( GetCVarBool("screenEdgeFlash") ) then
			CombatFeedback_StartFullscreenStatus();
		end
	elseif ( event == "PLAYER_REGEN_ENABLED" ) then
		self.onHateList = nil;
		ALUF_PlayerFrame_UpdateStatus(self);

		CombatFeedback_StopFullscreenStatus(self);
	elseif ( event == "PLAYER_UPDATE_RESTING" ) then
		ALUF_PlayerFrame_UpdateStatus(self);
	elseif ( event == "PARTY_LEADER_CHANGED" or event == "GROUP_ROSTER_UPDATE" ) then
		ALUF_PlayerFrame_UpdatePartyLeader(self);
		ALUF_PlayerFrame_UpdateReadyCheck(self);
	elseif ( event == "PARTY_LOOT_METHOD_CHANGED" ) then
		ALUF_PlayerFrame_UpdatePartyLeader(self);
	elseif ( event == "VOICE_START") then
		if ( arg1 == "player" ) then
			ALUF_PlayerFrame_UpdateVoiceStatus(true);
		end
	elseif ( event == "VOICE_STOP" ) then
		if ( arg1 == "player" ) then
			ALUF_PlayerFrame_UpdateVoiceStatus(false);
		end
	elseif ( event == "READY_CHECK" or event == "READY_CHECK_CONFIRM" ) then
		ALUF_PlayerFrame_UpdateReadyCheck(self);
	elseif ( event == "READY_CHECK_FINISHED" ) then
		ReadyCheck_Finish(self.ReadyCheck, DEFAULT_READY_CHECK_STAY_TIME);
	elseif ( event == "UNIT_ENTERED_VEHICLE" ) then
		if ( arg1 == "player" ) then
			local unit;
			
			if ( UnitHasVehiclePlayerFrameUI("player") ) then
				unit = "vehicle";
			else
				unit = "player";
			end
			
			ArenaLive_UnitFrame_UpdateUnit(self, unit);
			ArenaLive_UnitFrame_Update(self);
			CloseDropDownMenus();
		end
	elseif ( event == "UNIT_EXITED_VEHICLE" ) then
		if ( arg1 == "player" ) then
			ArenaLive_UnitFrame_UpdateUnit(self, "player");
			ArenaLive_UnitFrame_UpdateUnit(ALUF_PetFrame, "pet");
			ArenaLive_UnitFrame_Update(ALUF_PetFrame);
			ArenaLive_UnitFrame_Update(self);
			CloseDropDownMenus();
		end
	elseif ( event == "PLAYER_FLAGS_CHANGED" ) then
	elseif ( event == "PLAYER_ROLES_ASSIGNED" ) then
		ALUF_PlayerFrame_UpdateRolesAssigned(self);
	elseif ( event == "PLAYER_SPECIALIZATION_CHANGED" ) then
		ALUF_PlayerFrame_AdjustAttachments(self);
	end
	
end



function ALUF_PlayerFrame_OnUpdate (self, elapsed)
	
	if ( self.statusTexture:IsShown() ) then
		local alpha = 255;
		local counter = self.statusCounter + elapsed;
		local sign    = self.statusSign;

		if ( counter > 0.5 ) then
			sign = -sign;
			self.statusSign = sign;
		end
		counter = mod(counter, 0.5);
		self.statusCounter = counter;

		if ( sign == 1 ) then
			alpha = (55  + (counter * 400)) / 255;
		else
			alpha = (255 - (counter * 400)) / 255;
		end
		self.statusTexture:SetAlpha(alpha);
		self.statusGlow:SetAlpha(alpha);
	end

end



function ALUF_PlayerFrame_UpdateRolesAssigned (self)

	local frame = self;
	local icon = self.roleIcon;
	local role = UnitGroupRolesAssigned("player");
	
	if ( role == "TANK" or role == "HEALER" or role == "DAMAGER") then
		icon:SetTexCoord(GetTexCoordsForRoleSmallCircle(role));
		icon:Show();
	else
		icon:Hide();
	end

end



function ALUF_PlayerFrame_UpdateVoiceStatus (status)
	
	if ( status ) then
		UIFrameFadeIn(ALUF_PlayerFrameSpeakerFrame, 0.2, ALUF_PlayerFrameSpeakerFrame:GetAlpha(), 1);
		VoiceChat_Animate(ALUF_PlayerFrameSpeakerFrame, 1);
	else
		UIFrameFadeOut(ALUF_PlayerFrameSpeakerFrame, 0.2, ALUF_PlayerFrameSpeakerFrame:GetAlpha(), 0);
		VoiceChat_Animate(ALUF_PlayerFrameSpeakerFrame, nil);
	end
	
end

function ALUF_PlayerFrame_UpdateReadyCheck(self)
	
	local readyCheckStatus = GetReadyCheckStatus("player");
	if ( readyCheckStatus ) then
		if ( readyCheckStatus == "ready" ) then
			ReadyCheck_Confirm(self.ReadyCheck, 1);
		elseif ( readyCheckStatus == "notready" ) then
			ReadyCheck_Confirm(self.ReadyCheck, 0);
		else -- "waiting"
			ReadyCheck_Start(self.ReadyCheck);
		end
	else
		self.ReadyCheck:Hide();
	end
	
end

function ALUF_PlayerFrame_UpdateStatus(self)
	
	if ( IsResting() ) then
		self.statusTexture:SetVertexColor(1.0, 0.88, 0.25, 1.0);
		self.statusTexture:Show();
		self.restIcon:Show();
		self.attackIcon:Hide();
		self.statusGlow.restGlow:Show();
		self.statusGlow.attackGlow:Hide();
		self.statusGlow:Show();
		self.attackBackground:Hide();
	elseif ( self.inCombat ) then
		self.levelText:Hide();
		self.statusTexture:SetVertexColor(1.0, 0.0, 0.0, 1.0);
		self.statusTexture:Show();
		self.attackIcon:Show();
		self.restIcon:Hide();
		self.statusGlow.attackGlow:Show();
		self.statusGlow.restGlow:Hide();
		self.statusGlow:Show();
		self.attackBackground:Hide();
	elseif ( self.onHateList ) then
		self.levelText:Hide();
		self.attackIcon:Show();
		self.restIcon:Hide();
		self.statusGlow:Hide();
		self.attackBackground:Hide();
	else
		self.levelText:Show();
		self.statusTexture:Hide();
		self.restIcon:Hide();
		self.attackIcon:Hide();
		self.statusGlow:Hide();
		self.attackBackground:Hide();
	end
end



function  ALUF_PlayerFrameMultiGroupFrame_OnLoad(self)
	self:RegisterEvent("GROUP_ROSTER_UPDATE");
	self:RegisterEvent("UPDATE_CHAT_COLOR");
	self:RegisterForClicks("LeftButtonUp", "RightButtonUp");
end



function ALUF_PlayerFrameMultiGroupFrame_OnEvent(self, event, ...)
	if ( event == "GROUP_ROSTER_UPDATE" ) then
		if ( IsInGroup(LE_PARTY_CATEGORY_HOME) and IsInGroup(LE_PARTY_CATEGORY_INSTANCE) ) then
			self:Show();
		else
			self:Hide();
		end
	elseif ( event == "UPDATE_CHAT_COLOR" ) then
		local public = ChatTypeInfo["INSTANCE_CHAT"];
		local private = ChatTypeInfo["PARTY"];
		self.homePartyIcon:SetVertexColor(private.r, private.g, private.b);
		self.instancePartyIcon:SetVertexColor(public.r, public.g, public.b);
	end
end



function ALUF_PlayerFrameMultiGroupFrame_OnEnter(self)
	GameTooltip_SetDefaultAnchor(GameTooltip, self);
	self.homePlayers = GetHomePartyInfo(self.homePlayers);

	if ( IsInRaid(LE_PARTY_CATEGORY_HOME) ) then
		GameTooltip:SetText(PLAYER_IN_MULTI_GROUP_RAID_MESSAGE, nil, nil, nil, nil, true);
		GameTooltip:AddLine(format(MEMBER_COUNT_IN_RAID_LIST, #self.homePlayers + 1), 1, 1, 1, true);
	else
		GameTooltip:AddLine(PLAYER_IN_MULTI_GROUP_PARTY_MESSAGE, 1, 1, 1, true);
		local playerList = self.homePlayers[1] or "";
		for i=2, #self.homePlayers do
			playerList = playerList..PLAYER_LIST_DELIMITER..self.homePlayers[i];
		end
		GameTooltip:AddLine(format(MEMBERS_IN_PARTY_LIST, playerList));
	end
	GameTooltip:Show();
end



function ALUF_PlayerFrame_AdjustAttachments(self)
	
	local castBarIsShown, castBarPosition, castHistoryIsShown, auraFrameIsShown, auraFramePosition, altPowerBar;
	local altPowerBaryOffsetmod = 0;
	local isEnabled = ARENALIVE_DATABASE[addonName]["frameTypes"][self.frameType]["enabled"];
	
	-- First check if the Frame is enabled. If not we can skip the rest.
	ArenaLive_ToggleBlizzFrame(PlayerFrame, isEnabled);
	
	if ( isEnabled ) then
		ArenaLive_UnitFrame_UpdateUnit(self, "player");
		PlayerFrame:SetScript("OnEvent", nil);
	else
		ArenaLive_UnitFrame_ResetFrame(self);
		ArenaLive_CastBar_ResetFrame(ALUF_PlayerFrameCastBar);
		ArenaLive_AuraFrame_ResetFrame(ALUF_PlayerFrameAuras);
		ArenaLive_CastHistory_ResetFrame(self.castHistory);
		self:Hide();
		PlayerFrame:SetScript("OnEvent", PlayerFrame_OnEvent);
		return;
	end	
	
	local _, class = UnitClass("player");	
	if ( class == "WARLOCK" ) then
		altPowerBar = WarlockPowerFrame:IsShown();
	elseif ( class == "SHAMAN" ) then
		altPowerBar = true;
	elseif ( class == "DRUID" ) then
		altPowerBar = EclipseBarFrame:IsShown();
	elseif ( class == "PALADIN" ) then
		altPowerBar = PaladinPowerBar:IsShown();
	elseif ( class == "DEATHKNIGHT" ) then
		altPowerBar = RuneFrame:IsShown();
	elseif ( class == "PRIEST" ) then
		altPowerBar = PriestBarFrame:IsShown();
	elseif ( class == "MONK" ) then
		altPowerBar = MonkHarmonyBar:IsShown();
	end
	
	if ( altPowerBar ) then
		if ( class == "PALADIN" ) then
			altPowerBaryOffsetmod = -37; -- HolyPower is pretty large
		else
			altPowerBaryOffsetmod = -25;
		end
	end
	
	if ( self.castBar ) then
		castBarIsShown = ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["castBar"]["isShown"];
		castBarPosition = ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["castBar"]["position"];
	end
	
	if ( self.castHistory ) then
		castHistoryIsShown = ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["castHistory"]["isShown"];
	end
	
	if ( self.auraFrame ) then
		auraFrameIsShown = ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["auraFrame"]["isShown"];
		auraFramePosition = ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["auraFrame"]["position"];
	end
	
	if ( castBarIsShown ) then
		ArenaLive_CastBar_UpdateUnit(ALUF_PlayerFrameCastBar, "player");
		self.castBar:ClearAllPoints();
		
		if ( castBarPosition == auraFramePosition and auraFrameIsShown ) then
			--[[ castBar and auraFrame are either both above or below the unitframe. In this case we must anchor the castbar
			to the auraFrame, so that it will change it's position according to the height of the auraFrame. ]]--
			
			if ( castBarPosition == "BELOW" ) then
				self.castBar:SetPoint("TOPLEFT", self.auraFrame, "BOTTOMLEFT", 21, -3)
			elseif ( castBarPosition == "ABOVE" ) then
				self.castBar:SetPoint("BOTTOMLEFT", self.auraFrame, "TOPLEFT", 21, 3)
			end
		else
			--[[ Castbar and  auraFrame are on different spots, so the castbar needs to be anchored to the unitFrame itself]]--
			
			if ( castBarPosition == "BELOW" ) then
				self.castBar:SetPoint("TOPRIGHT", self, "BOTTOMRIGHT", -10, altPowerBaryOffsetmod-3)
			elseif ( castBarPosition == "ABOVE" ) then
				self.castBar:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", -10, 3)
			end
		end
	else
		ArenaLive_CastBar_ResetFrame(ALUF_PlayerFrameCastBar);
	end
	
	
	if ( castHistoryIsShown and castBarIsShown ) then
		-- We only show castHistory in combination with castBar at the moment.
		
		ArenaLive_CastHistory_UpdateUnit(self.castHistory, "player");
		
		if ( castBarPosition == "BELOW" ) then
			self.castHistory:ClearAllPoints();
			self.castHistory:SetPoint("TOPLEFT", self.castBar.border, "BOTTOMLEFT", 0, -2);
		elseif ( castBarPosition == "ABOVE" ) then
			self.castHistory:ClearAllPoints();
			self.castHistory:SetPoint("BOTTOMLEFT", self.castBar.border, "TOPLEFT", 0, 2);
		end
	else
		ArenaLive_CastHistory_ResetFrame(self.castHistory)
	end
	
	if ( auraFrameIsShown ) then
		self.auraFrame:ClearAllPoints();
		
		if ( auraFramePosition == "BELOW" ) then
			self.auraFrame:SetPoint("TOPLEFT", self, "BOTTOMLEFT", 33, altPowerBaryOffsetmod+3);
			ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["auraFrame"]["growUpwards"] = false;
		elseif ( auraFramePosition == "ABOVE" ) then
			self.auraFrame:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 33, 2);
			ARENALIVE_DATABASE["ArenaLiveUnitFrames"]["frameTypes"]["playerFrame"]["auraFrame"]["growUpwards"] = true;
		end
		
		ArenaLive_AuraFrame_UpdateUnit(ALUF_PlayerFrameAuras, "player");
	else
		ArenaLive_AuraFrame_ResetFrame(ALUF_PlayerFrameAuras)
	end
end